/*!
* backbone.leaflet
* v0.1.0 - 2013-09-13
* http://github.com/LuizArmesto/backbone.leaflet
* (c) Luiz Armesto; MIT License
*/

!function(a,b,c){"use strict";a.$;var d={};d.VERSION="0.1.0";var e=a.Leaflet;a.Leaflet=d,d.noConflict=function(){return a.Leaflet=e,this};var f=d.GeoModel=a.Model.extend({keepId:!1,set:function(c,d,e){var f,g,h,i;return f=arguments,"object"==typeof c&&(g=c,e=d),g&&g.type&&"Feature"===g.type&&(h=b.clone(g.properties)||{},i=b.clone(g.geometry)||null,i&&(i.coordinates=i.coordinates.slice()),h.geometry=i,g[this.idAttribute]&&(h[this.idAttribute]=g[this.idAttribute]),f=[h,e]),a.Model.prototype.set.apply(this,f)},toJSON:function(a){var c,d,e;a=a||{},c=b.clone(this.attributes),d=b.omit(c,"geometry"),a.cid&&(d.cid=this.cid),e=b.clone(c.geometry)||null,e&&(e.coordinates=e.coordinates.slice());var f={type:"Feature",geometry:e,properties:d};return this.keepId&&(f[this.idAttribute]=this.id),f}}),g=d.GeoCollection=a.Collection.extend({model:f,reset:function(c,d){return c&&!b.isArray(c)&&c.features&&(c=c.features),a.Collection.prototype.reset.apply(this,[c,d])},toJSON:function(){var b=a.Collection.prototype.toJSON.apply(this,arguments);return{type:"FeatureCollection",features:b}}}),h=d.PopupView=function(b){a.View.apply(this,arguments),this.popup=new c.Popup(b)};h.extend=a.View.extend,b.extend(h.prototype,a.View.prototype,{constructor:h,template:b.template("<strong><%= properties.name %></strong><p><%= properties.description %></p>"),render:function(){return this.popup._content!==this.el&&this.popup.setContent(this.el),this.$el.html(this.template(this.model.toJSON())),this.popup._update(),this},setModel:function(a){return a&&(this.model&&this.stopListening(this.model),this.model=a,this.listenTo(a,"change",this.render)),this}});var i=function(a,b){var d=this._getModelByFeature(a);return new c.Marker(b,this.layerStyle(d))},j=function(a){var b=this._getModelByFeature(a);return this.modelFilter(b)},k=function(a){var b=this._getModelByFeature(a);return this.layerStyle(b)},l=function(a,c){this._layers[a.properties.cid]=c,c.cid=a.properties.cid;var d=["click","dblclick","mouseover","mouseout","contextmenu","dragstart","predrag","drag","dragend","move","add","remove","layeradd","layerremove"];b.each(d,function(a){c.on(a,function(){var b=c._map;b.fire.apply(b,["layer_"+a].concat(arguments))})})},m=function(a){switch(a){case"marker":return"Point";case"polygon":case"rectangle":return"Polygon";case"polyline":return"LineString";default:throw new Error("GeoJSON don't allows "+a+" as geometry.")}},n=function(a,c){var d,e=[];return b.isFunction(a.getLatLngs)?d=a.getLatLngs():b.isFunction(a.getLatLng)&&(d=[a.getLatLng()]),b.each(d,function(a){e.push([a.lng,a.lat])}),"polygon"===c||"rectangle"===c?e=[e]:"marker"===c&&(e=e[0]),e},o=function(a,b){return{type:"Feature",geometry:{type:m(b),coordinates:n(a,b)},properties:{}}},p=/^(\S+)\s*(.*)$/,q=d.MapView=function(){if(a.View.apply(this,arguments),this._ensureMap(),this._initDrawControl(),this._layers={},this._layer=this._getLayer(),this._layer.addTo(this.map),this.collection){if(!this.collection instanceof g)throw new Error('The "collection" option should be instance of "GeoCollection" to be used within Map view');this.listenTo(this.collection,"reset",this._onReset),this.listenTo(this.collection,"add",this._onAdd),this.listenTo(this.collection,"remove",this._onRemove),this.listenTo(this.collection,"change",this._onChange),this.redraw()}};q.extend=a.View.extend,b.extend(q.prototype,a.View.prototype,{constructor:q,defaultLayerOptions:{pointToLayer:i,filter:j,style:k,onEachFeature:l},defaultStyle:{},defaultMapOptions:{center:[-23.5,-46.6167],zoom:14,drawControl:null!=c.Draw},defaultPopupOptions:{},render:function(){this.map.invalidateSize()},redraw:function(){return this._layers={},this._layer.clearLayers(),this._layer.addData(this.collection.toJSON({cid:!0})),this},delegateEvents:function(c){this._ensureMap(),this._ensurePopup();var d="delegateEvents"+this.cid;if(a.View.prototype.delegateEvents.apply(this,arguments),!c&&!(c=b.result(this,"events")))return this;var e=function(a){return function(b){var c=b[0];a(c)}};this._leaflet_events={};for(var f in c){var g=c[f];if(b.isFunction(g)||(g=this[c[f]]),!g)throw new Error('Method "'+c[f]+'" does not exist');var h=f.match(p),i=h[1],j=h[2];g=b.bind(g,this),("map"===j||"layer"===j)&&("layer"===j&&(i="layer_"+i,g=e(g)),this.map.on(i,g,d),this._leaflet_events[i]=g)}return this},undelegateEvents:function(){var b="delegateEvents"+this.cid;return this.map.off(this._leaflet_events||{},b),this._leaflet_events=null,a.View.prototype.undelegateEvents.apply(this,arguments)},getTileLayer:function(){return new c.TileLayer("http://{s}.mqcdn.com/tiles/1.0.0/map/{z}/{x}/{y}.png",{attribution:'Data, imagery and map information provided by <a href="http://www.mapquest.com/">MapQuest</a>, <a href="http://www.openstreetmap.org/">Open Street Map</a> and contributors, <a href="http://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>.',subdomains:["otile1","otile2","otile3","otile4"]})},openPopup:function(a,b){this._ensurePopup();var d=this.collection.get(a),e=this._getLayerByModel(d);e.bindPopup(""),c.setOptions(this.popup,e._popup.options),e._popup=this.popup,b?this.popup.setContent(b):(this.popupView.setModel(d),this.popupView.render()),e.openPopup()},_ensurePopup:function(){if(!this.popup){this.popupOptions=b.defaults(this.options.popup||{},this.defaultPopupOptions);var a=this.options.popupView||h;this.popupView=new a(this.popupOptions),this.popup=this.popupView.popup}},_ensureMap:function(){this.map||(this.mapOptions=b.defaults(this.options.map||{},this.defaultMapOptions),this.map=new c.Map(this.el,this.mapOptions),this.tileLayer=this.getTileLayer(),this.tileLayer.addTo(this.map))},_initDrawControl:function(){var a=this;null!==c.Draw&&this.mapOptions.drawControl&&this.map.on("draw:created",function(b){var c,d;a._layer.addLayer(b.layer),c=o(b.layer,b.layerType),d=new a.collection.model(c),b.layer.cid=d.cid,c.properties.cid=d.cid,l.apply(a,[c,b.layer]),a._updateLayerStyle(b.layer,d),a.collection.add(d)})},modelFilter:function(a){return a?this.options.filter&&b.isFunction(this.options.filter)?this.options.filter.apply(this,arguments):!this._layers[a.cid]:!0},layerStyle:function(a){return a?this.options.style?b.isFunction(this.options.style)?this.options.style.apply(this,arguments):this.options.style:a.getStyle&&b.isFunction(a.getStyle)?a.getStyle():this.defaultStyle:this.defaultStyle},_getModelByFeature:function(a){var c=b.where(this.collection.models,{cid:a.properties.cid});return c[0]},_getLayerByModel:function(a){return this._layers[a.cid]},_getLayer:function(){var a,d;return d=b.defaults(this.options.layer||{},this.defaultLayerOptions),a=["pointToLayer","filter","style","onEachFeature"],b.each(a,function(a){d[a]=b.bind(d[a],this)},this),new c.GeoJSON(null,d)},_onReset:function(){this.redraw()},_onAdd:function(a){this._getLayerByModel(a)||this._layer.addData(a.toJSON({cid:!0}))},_onRemove:function(a){var b=this._layers[a.cid];b&&(this._layer.removeLayer(b),this._layers[a.cid]=null)},_onChange:function(a){var b=this._layers[a.cid];a.hasChanged("geometry")?(this._onRemove(a),this._onAdd(a)):this._updateLayerStyle(b,a)},_updateLayerStyle:function(a,c){var d=this.layerStyle(c);a.setStyle&&b.isFunction(a.setStyle)?a.setStyle(d):a.setIcon&&b.isFunction(a.setIcon)&&a.setOpacity&&b.isFunction(a.setOpacity)&&(d.icon&&a.setIcon(d.icon),d.opacity&&a.setOpacity(d.opacity))}}),d.SatelliteView=q.extend({defaultMapOptions:{center:[-23.5,-46.6167],zoom:11},getTileLayer:function(){return new c.TileLayer("http://{s}.mqcdn.com/tiles/1.0.0/sat/{z}/{x}/{y}.jpg",{attribution:'Data and imagery provided by <a href="http://www.mapquest.com/">MapQuest</a>. Portions Courtesy NASA/JPL-Caltech and U.S. Depart. of Agriculture, Farm Service Agency.',subdomains:["otile1","otile2","otile3","otile4"]})}})}(Backbone,_,L);